/*
 * Creator: Rosalva Gallardo-Valencia
 * Course: Inf111, Winter 2009
 * 
 * Created on Feb 28, 2009
 * 
 * Copyright, 2009 University of California. 
 * 
 */
package edu.uci.ics.inf111.dvdvendor.app;

import junit.framework.TestCase;

/** 
* This class contains JUnit test cases for DVD.java.
* 
*/
public class DVDTest extends TestCase {

	DVD firstDVD, differentDVD;
	BarCode firstBarCode, differentBarCode;
	String firstCode, firstTitle, firstPlot, firstRunningTime, firstStarring;	
	String differentCode, differentTitle, differentPlot, differentRunningTime, differentStarring;
	double firstPrice, differentPrice;
	Utils.genre[] firstGenre, differentGenre;
	
	public DVDTest(String name) {
		super(name);
	}
	/**
	 * Initialize variables per each test method 
	 */	
	protected void setUp() throws Exception {
		super.setUp();
		firstCode = "024543213710";
		firstBarCode = new BarCode(firstCode);
		firstTitle = "Mamma Mia!";
		firstPrice = 1.00;
		firstPlot = "MAMMA MIA became a Broadway smash when it hit Broadway back in 2001. With a story framed around the music of the Swedish pop band Abba, crowds loved its raucous, dance party vibe. Now it comes to DVD, with some truly delightful performances from the likes of Meryl Streep and Pierce Brosnan. It is the story of Sophie, a young woman living on a picturesque Greek island with her mother, Donna. Together, Donna and Sophie run a ramshackle island inn, and they are in the midst of preparing for Sophie's wedding.";
		firstGenre = new Utils.genre[]{Utils.genre.COMEDY, Utils.genre.MUSICAL, Utils.genre.HITMOVIES};
		firstRunningTime = "1:48";
		firstStarring = "Colin Firth,Meryl Streep,Pierce Brosnan";
		
		firstDVD = new DVD(firstBarCode, firstTitle, firstPrice, firstPlot,firstGenre,
				firstRunningTime, firstStarring );	
		
		differentCode = "071009003507";
		differentBarCode = new BarCode(differentCode);
		differentTitle = "The Dark Knight";
		differentPrice = 3.00;
		differentPlot = "The follow-up to Batman Begins, The Dark Knight reunites director Christopher Nolan and star Christian Bale, who reprises the role of Batman/Bruce Wayne in his continuing war on crime. With the help of Lt. Jim Gordon and District Attorney Harvey Dent, Batman sets out to destroy organized crime in Gotham for good. The triumvirate proves effective, but soon find themselves prey to a rising criminal mastermind known as The Joker, who thrusts Gotham into anarchy and forces Batman closer to crossing the fine line between hero and vigilante.";
		differentGenre = new Utils.genre[]{Utils.genre.ACTION_ADVENTURE, Utils.genre.SCIFI_FANTASY, Utils.genre.SUSPENSE, Utils.genre.HITMOVIES};
		differentRunningTime = "2:32";
		differentStarring = "Christian Bale,Gary Oldman,Heath Ledger";
		
		differentDVD = new DVD(differentBarCode, differentTitle, differentPrice, differentPlot,
				differentGenre, differentRunningTime, differentStarring );	
		

	}
	/**
	 * Free variables per each test method
	 */
	protected void tearDown() throws Exception {
		super.tearDown();
		
		firstCode = null;
		firstBarCode = null;
		firstTitle = null;
		firstPrice = 0.0;
		firstPlot = null;
		firstGenre = null;
		firstRunningTime = null;
		firstStarring = null;
		
		firstDVD = null;	
		
		differentCode = null;
		differentBarCode = null;
		differentTitle = null;
		differentPrice = 0.0;
		differentPlot = null;
		differentGenre = null;
		differentRunningTime = null;
		differentStarring = null;
		
		differentDVD = null;
	}
	/*	We're not testing this because the constructor doesn't contain any logic
	 * Calling the constructor in setUp is sufficient.
	 * 
		public void testDVD() {
		fail("Not yet implemented");
		}
	 */
	/**
	 * This method will test the getBarCode method. It will test it with
	 * a correct BarCode and a wrong BarCode.
	 */
	public void testGetBarCode() {
		
		// test with a correct BarCode
		assertEquals(firstBarCode, firstDVD.getBarCode());
		
		// test with a different BarCode
		assertFalse(differentBarCode == firstDVD.getBarCode());		
	}
	/**
	 * This method will test the getPrice method. It will test it with
	 * a correct price and a wrong price.
	 */
	public void testGetPrice() {
		
		// test with a correct Price
		assertEquals(firstPrice, firstDVD.getPrice());
		
		// test with a different Price
		assertFalse(differentPrice == firstDVD.getPrice());	
	}
	/**
	 * This method will test the getTitle method. It will test it with
	 * a correct title and a wrong title.
	 */
	public void testGetTitle() {
		// test with a correct Title
		assertEquals(firstTitle, firstDVD.getTitle());
		
		// test with a different Title
		assertFalse(differentTitle == firstDVD.getTitle());	
	}
	/**
	 * This method will test the getPlot method. It will test it with
	 * a correct plot and a wrong plot.
	 */
	public void testGetPlot() {
		// test with a correct Plot
		assertEquals(firstPlot, firstDVD.getPlot());
		
		// test with a different Plot
		assertFalse(differentPlot == firstDVD.getPlot());
	}
	/**
	 * This method will test the getGenre method. It will test it with
	 * a correct genre and a wrong genre.
	 */
	public void testGetGenre() {
		// test with a correct Genre
		assertEquals(firstGenre, firstDVD.getGenre());
		
		// test with a different Genre
		assertFalse(differentGenre == firstDVD.getGenre());
	}
	/**
	 * This method will test the getRunningTime method. It will test it with
	 * a correct runningTime and a wrong runningTime.
	 */
	public void testGetRunningTime() {
		// test with a correct RunningTime
		assertEquals(firstRunningTime, firstDVD.getRunningTime());
		
		// test with a different RunningTime
		assertFalse(differentRunningTime == firstDVD.getRunningTime());	
	}
	/**
	 * This method will test the getStarring method. It will test it with
	 * a correct starring and a wrong starring.
	 */
	public void testGetStarring() {
		// test with a correct Starring
		assertEquals(firstStarring, firstDVD.getStarring());
		
		// test with a different Starring
		assertFalse(differentStarring == firstDVD.getStarring());
	}

}
